using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_General._3_Vistas.Controladoras;
using Exferia_General._3_Vistas.Listados;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;
using System.Linq;

namespace Exferia_General._3_Vistas
{
    public partial class P_Empresa_Seleccion : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Propiedades Privadas
        public ABS_Listado g_obj_ABS_Listado = null;
        private P_Empresa_Seleccion_Controladora g_obj_Controladora;

        private INTERNO_ConfiguracionPantalla_Modelo g_mdl_INTERNO_ConfiguracionPantalla_Modelo = null;

        internal List<string> g_lst_ColumnasAMostrar = new List<string>();

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;
        #endregion

        #region Objetos en Pantalla
       

        // Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaTrabajo { get { return ex_usc_P_Empresa_Seleccion_FechaTrabajo; } }

        // Exferia_DataGridView
        internal Exferia_DataGridView Exferia_DataGridView_Empresas { get { return ex_dgv_P_Empresa_Seleccion_Empresas; } }
        internal Exferia_DataGridView Exferia_DataGridView_Delegacion { get { return ex_dgv_P_Empresa_Seleccion_Delegacion; } }
        internal Exferia_DataGridView Exferia_DataGridView_Almacen { get { return ex_dgv_P_Empresa_Seleccion_Almacen; } }

        // Exferia_Label_SinColor
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Empresa { get { return ex_lbl_Empresa; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Delegacion { get { return ex_lbl_Delegacion; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Almacen { get { return ex_lbl_Almacen; } }

        #endregion

        #region Constructor
        public P_Empresa_Seleccion()
        {
            InitializeComponent();

            try
            {
                //Repintar los controles de la pantalla
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Fecha Actual 
                ex_usc_P_Empresa_Seleccion_FechaTrabajo.Exferia_FechaSeleccion_Fecha = DateTime.Now.ToString("dd/MM/yyyy");

                g_obj_Controladora = new P_Empresa_Seleccion_Controladora(this);

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO;
                P_Base_FechaTrabajo = Variables.G_DTT_FECHA_INICIAL_PORDEFECTO;
                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception)
                    { }
                }
                //....................................................................................................

                g_obj_ABS_Listado = new ABS_Listado_GEN_Empresas();

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(Variables.G_STR_OPCION_GEN_EMPRESASELECCION);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
                ex_btn_P_Empresa_Seleccion_Grabar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_EMPRESASELECCION, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //cargar los datos de configuracion de la pantalla
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_ABS_Listado.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo = Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_ABS_Listado.NOMBRELISTADO_ALMACENARCONFIGURACION()];
                    }
                }
            }
            catch (Control_Errores)
            {
                
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Empresa_Seleccion) + "/" + nameof(P_Empresa_Seleccion));
            }
        }
        #endregion

        #region Inicio Pantalla
        private void P_Empresa_Seleccion_Shown(object sender, EventArgs e)
        {
            if (P_Base_ValoresGenerales != null)
            {
                g_obj_Controladora.g_lng_idEmpresa = P_Base_ValoresGenerales.lng_idEmpresa;
                g_obj_Controladora.g_lng_idDelegacion = P_Base_ValoresGenerales.Delegacion != null ? P_Base_ValoresGenerales.Delegacion.id : -1;
                g_obj_Controladora.g_lng_idAlmacen = P_Base_ValoresGenerales.Almacenes != null ? P_Base_ValoresGenerales.Almacenes.id : -1;
            }

            //Poner Fecha por defecto
            if (Variables.G_DTT_FECHA_INICIAL_PORDEFECTO != null)
            {
                Exferia_FechaSeleccion_FechaTrabajo.Exferia_FechaSeleccion_Fecha = Variables.G_DTT_FECHA_INICIAL_PORDEFECTO.ToString("dd/MM/yyyy");
            }

           Funciones.Poner_Foco_Objeto(this, Exferia_FechaSeleccion_FechaTrabajo);


            g_obj_Controladora.Rellenar_Empresas();
        }
        #endregion

        #region Botones de grabar, insertar , borrar y ver
        private void ex_btn_P_Empresa_Seleccion_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_EMPRESASELECCION, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true))
            {
                g_obj_Controladora.GrabarDatos();
            }
        }
        #endregion

        #region Eventos y Procedimientos Publicos
        public override void P_Base_ActualizarRegistro(long _lng_id, G_ENUM_TIPOACCION _enum_TipoAccion)
        {
            g_obj_Controladora.Rellenar_Empresas();
        }
        #endregion

        #region Empresa
        private void ex_dgv_P_Empresa_Seleccion_Empresas_SelectionChanged(object sender, EventArgs e)
        {
            if (!g_obj_Controladora.g_bol_Rellenando_Empresas)
            {
                g_obj_Controladora.g_lng_idEmpresa = -1;
                g_obj_Controladora.g_lng_idDelegacion = -1;
                g_obj_Controladora.g_lng_idAlmacen = -1;

                if (ex_dgv_P_Empresa_Seleccion_Empresas.SelectedRows.Count > 0)
                {
                    g_obj_Controladora.g_lng_idEmpresa = long.Parse(ex_dgv_P_Empresa_Seleccion_Empresas.SelectedRows[0].Cells[0].Value.ToString());

                }
               
                g_obj_Controladora.Rellenar_Delegaciones();
            }
        }

        #region Botones
        private void ex_btn_P_Empresa_Seleccion_Add_Click(object sender, EventArgs e)
        {
            Add();
        }
        private void Add()
        {
            try
            {
                if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_EMPRESA, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true))
                {
                    INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_EMPRESA);

                    //Abrir mantenimiento
                    P_Empresa frm_P_Empresa = new P_Empresa(Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO, mdl_INTERNO_OpcionesDetalle_Modelo);
                    frm_P_Empresa.P_Base_Campo_1 = "";
                    frm_P_Empresa.P_Base_Campo_2 = "";
                    frm_P_Empresa.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                    frm_P_Empresa.P_Base_PantallaOrigen = this;
                    frm_P_Empresa.P_Base_TipoAperturaPantalla = 0;
                    frm_P_Empresa.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";


                    Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_Empresa, Variables.G_STR_OPCION_GEN_EMPRESA);
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Empresa_Seleccion) + "/" + nameof(Add));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_ERROR_SELECCIONAR_REGISTRO());
            }
        }

        private void ex_btn_P_Empresa_Seleccion_Ver_Click(object sender, EventArgs e)
        {
            Ver_Modificar();
        }
        private void ex_dgv_P_Empresa_Seleccion_Empresas_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Ver_Modificar();
        }
        private void Ver_Modificar()
        {
            if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_EMPRESA, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Ver, true))
            {
                if (ex_dgv_P_Empresa_Seleccion_Empresas.Rows.Count > 0 && ex_dgv_P_Empresa_Seleccion_Empresas.SelectedRows.Count > 0)
                {
                    try
                    {
                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_EMPRESA);

                        //Valor Seleccionado
                        dynamic dnm_ValorSeleccionado = long.Parse(ex_dgv_P_Empresa_Seleccion_Empresas.SelectedRows[0].Cells[0].Value.ToString());

                        //Abrir mantenimiento
                        P_Empresa frm_P_Empresa = new P_Empresa(Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO, mdl_INTERNO_OpcionesDetalle_Modelo);
                        frm_P_Empresa.P_Base_Campo_1 = "";
                        frm_P_Empresa.P_Base_Campo_2 = "";
                        frm_P_Empresa.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                        frm_P_Empresa.P_Base_PantallaOrigen = this;
                        frm_P_Empresa.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper();
                        frm_P_Empresa.P_Base_id = dnm_ValorSeleccionado;
                        frm_P_Empresa.P_Base_TipoAperturaPantalla = 1;

                        Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_Empresa, Variables.G_STR_OPCION_GEN_EMPRESA);
                    }
                    catch (Exception ex)
                    {
                        Control_Errores.Errores_Log("", ex, nameof(P_Empresa_Seleccion) + "/" + nameof(Ver_Modificar));
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_ERROR_SELECCIONAR_REGISTRO());
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }

        private void ex_btn_P_Empresa_Seleccion_Actualizar_Click(object sender, EventArgs e)
        {
            g_obj_Controladora.Rellenar_Empresas();
        }
        #endregion
        #endregion

        #region Delegacion
        private void ex_dgv_P_Empresa_Seleccion_Delegacion_SelectionChanged(object sender, EventArgs e)
        {
            if (!g_obj_Controladora.g_bol_Rellenando_Delegaciones)
            {
                g_obj_Controladora.g_lng_idDelegacion = -1;
                g_obj_Controladora.g_lng_idAlmacen = -1;

                if (ex_dgv_P_Empresa_Seleccion_Delegacion.SelectedRows.Count > 0)
                {
                    g_obj_Controladora.g_lng_idDelegacion = long.Parse(ex_dgv_P_Empresa_Seleccion_Delegacion.SelectedRows[0].Cells[0].Value.ToString());

                }

                g_obj_Controladora.Rellenar_Almacenes();
            }
        }

        #region Botones
        private void ex_btn_P_Empresa_Seleccion_Delegacion_Add_Click(object sender, EventArgs e)
        {
            Add_Delegacion();
        }
        private void Add_Delegacion()
        {
            try
            {
                if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_DELEGACION, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true))
                {
                    if (g_obj_Controladora.g_lst_GEN_Delegaciones == null || g_obj_Controladora.g_lst_GEN_Delegaciones.Count==0)
                    {
                        INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo_GRABACIONINICIAL = g_obj_Controladora.GrabarDatos_Final();
                        if (!mdl_INTERNO_ValorDevuelto_Modelo_GRABACIONINICIAL.TodoCorrecto)
                        {
                            Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo_GRABACIONINICIAL.Mensaje);
                            return;
                        }
                    }

                    INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_DELEGACION);

                    //Abrir mantenimiento
                    P_Delegacion frm_P_Delegacion = new P_Delegacion(Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO, mdl_INTERNO_OpcionesDetalle_Modelo);
                    frm_P_Delegacion.P_Base_Campo_1 = "";
                    frm_P_Delegacion.P_Base_Campo_2 = "";
                    frm_P_Delegacion.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                    frm_P_Delegacion.P_Base_PantallaOrigen = this;
                    frm_P_Delegacion.P_Base_TipoAperturaPantalla = 0;
                    frm_P_Delegacion.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";


                    Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_Delegacion, Variables.G_STR_OPCION_GEN_DELEGACION);
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Empresa_Seleccion) + "/" + nameof(Add_Delegacion));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_ERROR_SELECCIONAR_REGISTRO());
            }
        }

        private void ex_btn_P_Empresa_Seleccion_Delegacion_Ver_Click(object sender, EventArgs e)
        {
            Ver_Modificar_Delegacion();
        }
        private void ex_dgv_P_Empresa_Seleccion_Delegacion_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Ver_Modificar_Delegacion();
        }
        private void Ver_Modificar_Delegacion()
        {
            if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_DELEGACION, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Ver, true))
            {
                if (ex_dgv_P_Empresa_Seleccion_Delegacion.Rows.Count > 0 && ex_dgv_P_Empresa_Seleccion_Delegacion.SelectedRows.Count > 0)
                {
                    try
                    {
                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_DELEGACION);

                        //Valor Seleccionado
                        dynamic dnm_ValorSeleccionado = long.Parse(ex_dgv_P_Empresa_Seleccion_Delegacion.SelectedRows[0].Cells[0].Value.ToString());

                        //Abrir mantenimiento
                        P_Delegacion frm_P_Delegacion = new P_Delegacion(Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO, mdl_INTERNO_OpcionesDetalle_Modelo);
                        frm_P_Delegacion.P_Base_Campo_1 = "";
                        frm_P_Delegacion.P_Base_Campo_2 = "";
                        frm_P_Delegacion.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                        frm_P_Delegacion.P_Base_PantallaOrigen = this;
                        frm_P_Delegacion.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper();
                        frm_P_Delegacion.P_Base_id = dnm_ValorSeleccionado;
                        frm_P_Delegacion.P_Base_TipoAperturaPantalla = 1;

                        Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_Delegacion, Variables.G_STR_OPCION_GEN_DELEGACION);
                    }
                    catch (Exception ex)
                    {
                        Control_Errores.Errores_Log("", ex, nameof(P_Empresa_Seleccion) + "/" + nameof(Ver_Modificar_Delegacion));
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_ERROR_SELECCIONAR_REGISTRO());
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }


        private void ex_btn_P_Empresa_Seleccion_Delegacion_Actualizar_Click(object sender, EventArgs e)
        {
            g_obj_Controladora.Rellenar_Delegaciones();
        }
        #endregion
        #endregion

        #region Almacen
        private void ex_dgv_P_Empresa_Seleccion_Almacen_SelectionChanged(object sender, EventArgs e)
        {
            if (!g_obj_Controladora.g_bol_Rellenando_Almacenes)
            {
                g_obj_Controladora.g_lng_idAlmacen = -1;

                if (ex_dgv_P_Empresa_Seleccion_Almacen.SelectedRows.Count > 0)
                {
                    g_obj_Controladora.g_lng_idAlmacen = long.Parse(ex_dgv_P_Empresa_Seleccion_Almacen.SelectedRows[0].Cells[0].Value.ToString());
                }
            }
        }

        #region Botones
        private void ex_btn_P_Empresa_Seleccion_Almacen_Add_Click(object sender, EventArgs e)
        {
            Add_Almacen();
        }
        private void Add_Almacen()
        {
            try
            {
                if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_ALMACEN, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true))
                {
                    INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_ALMACEN);

                    //Abrir mantenimiento
                    P_Almacen frm_P_Almacen = new P_Almacen(Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO, mdl_INTERNO_OpcionesDetalle_Modelo);
                    frm_P_Almacen.P_Base_Campo_1 = "";
                    frm_P_Almacen.P_Base_Campo_2 = "";
                    frm_P_Almacen.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                    frm_P_Almacen.P_Base_PantallaOrigen = this;
                    frm_P_Almacen.P_Base_TipoAperturaPantalla = 0;
                    frm_P_Almacen.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";


                    Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_Almacen, Variables.G_STR_OPCION_GEN_ALMACEN);
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Empresa_Seleccion) + "/" + nameof(Add_Almacen));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_ERROR_SELECCIONAR_REGISTRO());
            }
        }

        private void ex_btn_P_Empresa_Seleccion_Almacen_Ver_Click(object sender, EventArgs e)
        {
            Ver_Modificar_Almacen();
        }
        private void ex_dgv_P_Empresa_Seleccion_Almacen_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Ver_Modificar_Almacen();
        }
        private void Ver_Modificar_Almacen()
        {
            if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_ALMACEN, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Ver, true))
            {
                if (ex_dgv_P_Empresa_Seleccion_Almacen.Rows.Count > 0 && ex_dgv_P_Empresa_Seleccion_Almacen.SelectedRows.Count > 0)
                {
                    try
                    {
                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_ALMACEN);

                        //Valor Seleccionado
                        dynamic dnm_ValorSeleccionado = long.Parse(ex_dgv_P_Empresa_Seleccion_Almacen.SelectedRows[0].Cells[0].Value.ToString());

                        //Abrir mantenimiento
                        P_Almacen frm_P_Almacen = new P_Almacen(Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO, mdl_INTERNO_OpcionesDetalle_Modelo);
                        frm_P_Almacen.P_Base_Campo_1 = "";
                        frm_P_Almacen.P_Base_Campo_2 = "";
                        frm_P_Almacen.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                        frm_P_Almacen.P_Base_PantallaOrigen = this;
                        frm_P_Almacen.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper();
                        frm_P_Almacen.P_Base_id = dnm_ValorSeleccionado;
                        frm_P_Almacen.P_Base_TipoAperturaPantalla = 1;

                        Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_Almacen, Variables.G_STR_OPCION_GEN_ALMACEN);
                    }
                    catch (Exception ex)
                    {
                        Control_Errores.Errores_Log("", ex, nameof(P_Empresa_Seleccion) + "/" + nameof(Ver_Modificar_Almacen));
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_ERROR_SELECCIONAR_REGISTRO());
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }

        private void ex_btn_P_Empresa_Seleccion_Almacen_Actualizar_Click(object sender, EventArgs e)
        {
            g_obj_Controladora.Rellenar_Almacenes();
        }
        #endregion
        #endregion

        private void P_Empresa_Seleccion_SizeChanged(object sender, EventArgs e)
        {
            int int_Margen_Inicial = 12;
            int int_Margen_EntreGrid = 6;
            int int_Margen_Final = 79;
            int int_Ancho_DataGridView = (((this.Width - int_Margen_Final) - int_Margen_EntreGrid) - int_Margen_Inicial) / 2;
            
            //Delegacion
            ex_dgv_P_Empresa_Seleccion_Delegacion.Size = new Size(int_Ancho_DataGridView, ex_dgv_P_Empresa_Seleccion_Delegacion.Size.Height);
           
            //Almacen
            ex_dgv_P_Empresa_Seleccion_Almacen.Location = new Point(ex_dgv_P_Empresa_Seleccion_Delegacion.Location.X + ex_dgv_P_Empresa_Seleccion_Delegacion.Width + int_Margen_EntreGrid, ex_dgv_P_Empresa_Seleccion_Almacen.Location.Y);
            ex_dgv_P_Empresa_Seleccion_Almacen.Size = new Size(int_Ancho_DataGridView, ex_dgv_P_Empresa_Seleccion_Almacen.Size.Height);
            ex_lbl_Almacen.Location = new Point(ex_dgv_P_Empresa_Seleccion_Almacen.Location.X , ex_lbl_Almacen.Location.Y);
            ex_btn_P_Empresa_Seleccion_Almacen_Add.Location = new Point(ex_dgv_P_Empresa_Seleccion_Almacen.Location.X+3, ex_btn_P_Empresa_Seleccion_Almacen_Add.Location.Y);
            ex_btn_P_Empresa_Seleccion_Almacen_Ver.Location = new Point(ex_dgv_P_Empresa_Seleccion_Almacen.Location.X+3+31, ex_btn_P_Empresa_Seleccion_Almacen_Ver.Location.Y);
            ex_btn_P_Empresa_Seleccion_Almacen_Actualizar.Location = new Point(ex_dgv_P_Empresa_Seleccion_Almacen.Location.X + 3 + 31+31, ex_btn_P_Empresa_Seleccion_Almacen_Actualizar.Location.Y);
        }

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        #endregion

        #region Controlar si se modifica algo

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }













        #endregion

        

        

        
    }
}
